don’t keep xml file
[build.git] / lbuild-initvm.sh
1 #!/bin/bash
2 # -*-shell-*-
3
4 #shopt -s huponexit
5
6 COMMAND=$(basename $0)
7 DIRNAME=$(dirname $0)
8 BUILD_DIR=$(pwd)
9
10 # pkgs parsing utilities
11 export PATH=$(dirname $0):$PATH
12
13 . build.common
14
15 DEFAULT_FCDISTRO=f20
16 DEFAULT_PLDISTRO=lxc
17 DEFAULT_PERSONALITY=linux64
18
19 COMMAND_LBUILD="lbuild-initvm.sh"
20 COMMAND_LTEST="ltest-initvm.sh"
21
22 ##########
23 # when creating build boxes we use private NAT'ed addresses for the VMs
24 # as per virbr0 that is taken care of by libvirt at startup
25 PRIVATE_BRIDGE="virbr0"
26 PRIVATE_PREFIX="192.168.122."
27 PRIVATE_GATEWAY="192.168.122.1"
28 # beware that changing this would break the logic of random_private_byte...
29 PRIVATE_MASKLEN=24
30
31 # we just try randomly in that range until a free IP address shows up
32 PRIVATE_ATTEMPTS=20
33
34 # constant
35 PUBLIC_BRIDGE=br0
36
37 # the network interface name as seen from the container
38 VIF_GUEST=eth0
39
40 ##############################
41 ## stolen from tests/system/template-qemu/qemu-bridge-init
42 # use /proc/net/dev instead of a hard-wired list
43 function gather_interfaces () {
44     python <<EOF
45 for line in file("/proc/net/dev"):
46     if ':' not in line: continue
47     ifname=line.replace(" ","").split(":")[0]
48     if ifname.find("lo")==0: continue
49     if ifname.find("br")==0: continue
50     if ifname.find("virbr")==0: continue
51     if ifname.find("tap")==0: continue
52     print ifname
53 EOF
54 }
55
56 function discover_interface () {
57     for ifname in $(gather_interfaces); do
58         ip link show $ifname | grep -qi 'state UP' && { echo $ifname; return; }
59     done
60     # still not found ? that's bad
61     echo unknown
62 }
63 ########## check for a free IP
64 function ip_is_busy () {
65     target=$1; shift
66     ping -c 1 -W 1 $target >& /dev/null
67 }
68
69 function random_private_byte () {
70     for attempt in $(seq $PRIVATE_ATTEMPTS); do
71         byte=$(($RANDOM % 256))
72         if [ "$byte" == 0 -o "$byte" == 1 ] ; then continue; fi
73         ip=${PRIVATE_PREFIX}${byte}
74         ip_is_busy $ip || { echo $byte; return; }
75     done
76     echo "Cannot seem to find a free IP address in range ${PRIVATE_PREFIX}.xx/24 after $PRIVATE_ATTEMPTS attempts - exiting"
77     exit 1
78 }
79
80 ########## networking -- ctd
81 function gethostbyname () {
82     hostname=$1
83     python -c "import socket; print socket.gethostbyname('"$hostname"')" 2> /dev/null
84 }
85
86 # e.g. 21 -> 255.255.248.0
87 function masklen_to_netmask () {
88     masklen=$1; shift
89     python <<EOF
90 import sys
91 masklen=$masklen
92 if not (masklen>=1 and masklen<=32): 
93   print "Wrong masklen",masklen
94   exit(1)
95 result=[]
96 for i in range(4):
97     if masklen>=8:
98        result.append(8)
99        masklen-=8
100     else:
101        result.append(masklen)
102        masklen=0
103 print ".".join([ str(256-2**(8-i)) for i in result ])
104   
105 EOF
106 }
107
108 #################### bridge initialization
109 function create_bridge_if_needed() {
110    
111     # turn on verbosity
112     set -x
113
114     # already created ? - we're done
115     ip addr show $PUBLIC_BRIDGE >& /dev/null && {
116         echo "Bridge already set up - skipping create_bridge_if_needed"
117         return 0
118     }
119
120     # find out the physical interface to bridge onto
121     if_lan=$(discover_interface)
122
123     ip addr show $if_lan &>/dev/null || {
124         echo "Cannot use interface $if_lan - exiting"
125         exit 1
126     }
127
128     #################### bride initialization
129     check_yum_installed bridge-utils
130
131     echo "========== $COMMAND: entering create_bridge - beg"
132     hostname
133     uname -a
134     ip addr show
135     ip route
136     echo "========== $COMMAND: entering create_bridge - end"
137
138     # disable netfilter calls for bridge interface (they cause panick on 2.6.35 anyway)
139     #
140     # another option would be to accept the all forward packages for
141     # bridged interface like: -A FORWARD -m physdev --physdev-is-bridged -j ACCEPT
142     sysctl net.bridge.bridge-nf-call-iptables=0
143     sysctl net.bridge.bridge-nf-call-ip6tables=0
144     sysctl net.bridge.bridge-nf-call-arptables=0
145
146     
147     #Getting host IP/masklen
148     address=$(ip addr show $if_lan | grep -v inet6 | grep inet | head --lines=1 | awk '{print $2;}')
149     [ -z "$address" ] && { echo "ERROR: Could not determine IP address for $if_lan" ; exit 1 ; }
150
151     broadcast=$(ip addr show $if_lan | grep -v inet6 | grep inet | head --lines=1 | awk '{print $4;}')
152     [ -z "$broadcast" ] && echo "WARNING: Could not determine broadcast address for $if_lan"
153
154     gateway=$(ip route show | grep default | awk '{print $3;}')
155     [ -z "$gateway" ] && echo "WARNING: Could not determine gateway IP"
156
157
158     # creating the bridge
159     echo "Creating bridge PUBLIC_BRIDGE=$PUBLIC_BRIDGE"
160     brctl addbr $PUBLIC_BRIDGE
161     brctl addif $PUBLIC_BRIDGE $if_lan
162     echo "Activating promiscuous mode if_lan=$if_lan"
163     ip link set $if_lan up promisc on
164     sleep 2
165     # rely on dhcp to re assign IP.. 
166     echo "Starting dhclient on $PUBLIC_BRIDGE"
167     dhclient $PUBLIC_BRIDGE
168     sleep 1
169
170     #Reconfigure the routing table
171     echo "Configuring gateway=$gateway"
172     ip route add default via $gateway dev $PUBLIC_BRIDGE
173     ip route del default via $gateway dev $if_lan
174     # at this point we have an extra route like e.g.
175     ## ip route show
176     #default via 138.96.112.250 dev br0
177     #138.96.112.0/21 dev em1  proto kernel  scope link  src 138.96.112.57
178     #138.96.112.0/21 dev br0  proto kernel  scope link  src 138.96.112.57
179     #192.168.122.0/24 dev virbr0  proto kernel  scope link  src 192.168.122.1
180     route_dest=$(ip route show | grep -v default | grep "dev $PUBLIC_BRIDGE" | awk '{print $1;}')
181     ip route del $route_dest dev $if_lan
182
183     echo "========== $COMMAND: exiting create_bridge - beg"
184     ip addr show
185     ip route show
186     echo "========== $COMMAND: exiting create_bridge - end"
187
188     # for safety
189     sleep 3
190     return 0
191
192 }
193
194 ##############################
195 # return yum or debootstrap
196 function package_method () {
197     fcdistro=$1; shift
198     case $fcdistro in
199         f[0-9]*|centos[0-9]*|sl[0-9]*) echo yum ;;
200         squeeze|wheezy|oneiric|precise|quantal|raring|saucy) echo debootstrap ;;
201         *) echo Unknown distro $fcdistro ;;
202     esac 
203 }
204
205 # return arch from debian distro and personality
206 function canonical_arch () {
207     personality=$1; shift
208     fcdistro=$1; shift
209     case $(package_method $fcdistro) in
210         yum)
211             case $personality in *32) echo i386 ;; *64) echo x86_64 ;; *) echo Unknown-arch-1 ;; esac ;;
212         debootstrap)
213             case $personality in *32) echo i386 ;; *64) echo amd64 ;; *) echo Unknown-arch-2 ;; esac ;;
214         *)
215             echo Unknown-arch-3 ;;
216     esac
217 }
218
219 # the new test framework creates /timestamp in /vservers/<name> *before* populating it
220 function almost_empty () { 
221     dir="$1"; shift ; 
222     # non existing is fine
223     [ ! -d $dir ] && return 0; 
224     # need to have at most one file
225     count=$(cd $dir; ls | wc -l); [ $count -le 1 ]; 
226 }
227
228 ##############################
229 function check_yum_installed () {
230     package=$1; shift
231     rpm -q $package >& /dev/null || yum -y install $package
232 }
233
234 function check_yumgroup_installed () {
235     group="$1"; shift
236     yum grouplist "$group" | grep -q Installed || { yum -y groupinstall "$group" ; }
237 }
238
239 ##############################
240 function fedora_install() {
241     set -x
242     set -e
243
244     mkdir -p /var/lock/subsys/
245     (
246         flock -n -x 200 || { echo "Cache repository is busy." ; return 1 ; }
247
248         if [ ! -e "$cache/rootfs" ]; then
249             echo "Getting cache download in $cache/rootfs ... "
250             fedora_download || { echo "Failed to download 'fedora base'"; return 1; }
251         else
252             echo "Updating cache $cache/rootfs ..."
253             if ! yum --installroot $cache/rootfs -y --nogpgcheck update ; then
254                 echo "Failed to update 'fedora base', continuing with last known good cache"
255             else
256                 echo "Update finished"
257             fi
258         fi
259
260         echo "Copy $cache/rootfs to $rootfs_path ... "
261         mkdir -p $rootfs_path
262         rsync -a $cache/rootfs/ $rootfs_path/
263         
264         return 0
265
266         ) 200>/var/lock/subsys/lxc
267
268     return $?
269 }
270
271 function fedora_download() {
272     set -x
273     # check the mini fedora was not already downloaded
274     INSTALL_ROOT=$cache/partial
275     echo $INSTALL_ROOT
276
277     # download a mini fedora into a cache
278     echo "Downloading fedora minimal ..."
279
280     mkdir -p $INSTALL_ROOT || { echo "Failed to create '$INSTALL_ROOT' directory" ; return 1; }
281
282     mkdir -p $INSTALL_ROOT/etc/yum.repos.d   
283     mkdir -p $INSTALL_ROOT/dev
284     mknod -m 0444 $INSTALL_ROOT/dev/random c 1 8
285     mknod -m 0444 $INSTALL_ROOT/dev/urandom c 1 9
286
287     # copy yum config and repo files
288     cp /etc/yum.conf $INSTALL_ROOT/etc/
289     cp /etc/yum.repos.d/fedora* $INSTALL_ROOT/etc/yum.repos.d/
290
291     # append fedora repo files with desired $release and $basearch
292     for f in $INSTALL_ROOT/etc/yum.repos.d/* ; do
293       sed -i "s/\$basearch/$arch/g; s/\$releasever/$release/g;" $f
294     done 
295
296     MIRROR_URL=http://mirror.onelab.eu/fedora/releases/$release/Everything/$arch/os
297     RELEASE_URL1="$MIRROR_URL/Packages/fedora-release-$release-1.noarch.rpm"
298     # with fedora18 the rpms are scattered by first name
299     RELEASE_URL2="$MIRROR_URL/Packages/f/fedora-release-$release-1.noarch.rpm"
300     RELEASE_TARGET=$INSTALL_ROOT/fedora-release-$release.noarch.rpm
301     found=""
302     for attempt in $RELEASE_URL1 $RELEASE_URL2; do
303         if curl -f $attempt -o $RELEASE_TARGET ; then
304             echo "Retrieved $attempt"
305             found=true
306             break
307         else
308             echo "Failed attempt $attempt"
309         fi
310     done
311     [ -n "$found" ] || { echo "Could not retrieve fedora-release rpm - exiting" ; exit 1; }
312     
313     mkdir -p $INSTALL_ROOT/var/lib/rpm
314     rpm --root $INSTALL_ROOT  --initdb
315     # when installing f12 this apparently is already present, so ignore result
316     rpm --root $INSTALL_ROOT -ivh $INSTALL_ROOT/fedora-release-$release.noarch.rpm || :
317     # however f12 root images won't get created on a f18 host
318     # (the issue here is the same as the one we ran into when dealing with a vs-box)
319     # in a nutshell, in f12 the glibc-common and filesystem rpms have an apparent conflict
320     # >>> file /usr/lib/locale from install of glibc-common-2.11.2-3.x86_64 conflicts 
321     #          with file from package filesystem-2.4.30-2.fc12.x86_64
322     # in fact this was - of course - allowed by f12's rpm but later on a fix was made 
323     #   http://rpm.org/gitweb?p=rpm.git;a=commitdiff;h=cf1095648194104a81a58abead05974a5bfa3b9a
324     # So ideally if we want to be able to build f12 images from f18 we need an rpm that has
325     # this patch undone, like we have in place on our f14 boxes (our f14 boxes need a f18-like rpm)
326
327     YUM="yum --installroot=$INSTALL_ROOT --nogpgcheck -y"
328     PKG_LIST="yum initscripts passwd rsyslog vim-minimal dhclient chkconfig rootfiles policycoreutils openssh-server openssh-clients"
329     echo "$YUM install $PKG_LIST"
330     $YUM install $PKG_LIST || { echo "Failed to download rootfs, aborting." ; return 1; }
331
332     mv "$INSTALL_ROOT" "$cache/rootfs"
333     echo "Download complete."
334
335     return 0
336 }
337
338 ##############################
339 function fedora_configure() {
340
341     set -x
342     set -e
343
344     # disable selinux in fedora
345     mkdir -p $rootfs_path/selinux
346     echo 0 > $rootfs_path/selinux/enforce
347
348     # set the hostname
349     case "$fcdistro" in 
350         f18|f2?)
351             cat <<EOF > ${rootfs_path}/etc/hostname
352 $GUEST_HOSTNAME
353 EOF
354             echo ;;
355         *)
356             cat <<EOF > ${rootfs_path}/etc/sysconfig/network
357 NETWORKING=yes
358 HOSTNAME=$GUEST_HOSTNAME
359 EOF
360             # set minimal hosts
361             cat <<EOF > $rootfs_path/etc/hosts
362 127.0.0.1 localhost $GUEST_HOSTNAME
363 EOF
364             echo ;;
365     esac
366
367     dev_path="${rootfs_path}/dev"
368     rm -rf $dev_path
369     mkdir -p $dev_path
370     mknod -m 666 ${dev_path}/null c 1 3
371     mknod -m 666 ${dev_path}/zero c 1 5
372     mknod -m 666 ${dev_path}/random c 1 8
373     mknod -m 666 ${dev_path}/urandom c 1 9
374     mkdir -m 755 ${dev_path}/pts
375     mkdir -m 1777 ${dev_path}/shm
376     mknod -m 666 ${dev_path}/tty c 5 0
377     mknod -m 666 ${dev_path}/tty0 c 4 0
378     mknod -m 666 ${dev_path}/tty1 c 4 1
379     mknod -m 666 ${dev_path}/tty2 c 4 2
380     mknod -m 666 ${dev_path}/tty3 c 4 3
381     mknod -m 666 ${dev_path}/tty4 c 4 4
382     mknod -m 600 ${dev_path}/console c 5 1
383     mknod -m 666 ${dev_path}/full c 1 7
384     mknod -m 600 ${dev_path}/initctl p
385     mknod -m 666 ${dev_path}/ptmx c 5 2
386
387     if [ "$(echo $fcdistro | cut -d"f" -f2)" -le "14" ]; then
388         fedora_configure_init
389     else
390         fedora_configure_systemd
391     fi
392
393     guest_ifcfg=${rootfs_path}/etc/sysconfig/network-scripts/ifcfg-$VIF_GUEST
394     ( [ -n "$BUILD_MODE" ] && write_guest_ifcfg_build || write_guest_ifcfg_test ) > $guest_ifcfg
395
396     fedora_configure_yum $lxc $fcdistro $pldistro
397
398     return 0
399 }
400
401 function fedora_configure_init() {
402     set -e
403     set -x
404     sed -i 's|.sbin.start_udev||' ${rootfs_path}/etc/rc.sysinit
405     sed -i 's|.sbin.start_udev||' ${rootfs_path}/etc/rc.d/rc.sysinit
406     # don't mount devpts, for pete's sake
407     sed -i 's/^.*dev.pts.*$/#\0/' ${rootfs_path}/etc/rc.sysinit
408     sed -i 's/^.*dev.pts.*$/#\0/' ${rootfs_path}/etc/rc.d/rc.sysinit
409     chroot ${rootfs_path} chkconfig udev-post off
410     chroot ${rootfs_path} chkconfig network on
411 }
412
413 # this code of course is for guests that do run on systemd
414 function fedora_configure_systemd() {
415     set -e
416     set -x
417     # so ignore if we can't find /etc/systemd at all 
418     [ -d ${rootfs_path}/etc/systemd ] || return 0
419     # otherwise let's proceed
420     ln -sf /lib/systemd/system/multi-user.target ${rootfs_path}/etc/systemd/system/default.target
421     touch ${rootfs_path}/etc/fstab
422     ln -sf /dev/null ${rootfs_path}/etc/systemd/system/udev.service
423 # Thierry - Feb 2013
424 # this was intended for f16 initially, in order to enable getty that otherwise would not start
425 # having a getty running is helpful only if ssh won't start though, and we see a correlation between
426 # VM's that refuse to lxc-stop and VM's that run crazy getty's
427 # so, turning getty off for now instead
428 #   #dependency on a device unit fails it specially that we disabled udev
429 #    sed -i 's/After=dev-%i.device/After=/' ${rootfs_path}/lib/systemd/system/getty\@.service
430     ln -sf /dev/null ${rootfs_path}/etc/systemd/system/"getty@.service"
431     rm -f ${rootfs_path}/etc/systemd/system/getty.target.wants/*service || :
432 # can't seem to handle this one with systemctl
433     chroot ${rootfs_path} chkconfig network on
434 }
435
436 # overwrite container yum config
437 function fedora_configure_yum () {
438     set -x 
439     set -e 
440     trap failure ERR INT
441
442     lxc=$1; shift
443     fcdistro=$1; shift
444     pldistro=$1; shift
445
446     # rpm --rebuilddb
447     chroot $rootfs_path rpm --rebuilddb
448
449     echo "Initializing yum.repos.d in $lxc"
450     rm -f $rootfs_path/etc/yum.repos.d/*
451
452     cat > $rootfs_path/etc/yum.repos.d/building.repo <<EOF
453 [fedora]
454 name=Fedora $release - $arch
455 baseurl=http://mirror.onelab.eu/fedora/releases/$release/Everything/$arch/os/
456 enabled=1
457 metadata_expire=7d
458 gpgcheck=1
459 gpgkey=http://mirror.onelab.eu/keys/RPM-GPG-KEY-fedora-$release-primary
460
461 [updates]
462 name=Fedora $release - $arch - Updates
463 baseurl=http://mirror.onelab.eu/fedora/updates/$release/$arch/
464 enabled=1
465 metadata_expire=7d
466 gpgcheck=1
467 gpgkey=http://mirror.onelab.eu/keys/RPM-GPG-KEY-fedora-$release-primary
468 EOF
469     
470     # for using vtest-init-lxc.sh as a general-purpose lxc creation wrapper
471     # just mention 'none' as the repo url
472     if [ -n "$REPO_URL" ] ; then
473         if [ ! -d $rootfs_path/etc/yum.repos.d ] ; then
474             echo "WARNING : cannot create myplc repo"
475         else
476             # exclude kernel from fedora repos 
477             yumexclude=$(pl_plcyumexclude $fcdistro $pldistro $DIRNAME)
478             for repo in $rootfs_path/etc/yum.repos.d/* ; do
479                 [ -f $repo ] && yumconf_exclude $repo "exclude=$yumexclude" 
480             done
481             # the build repo is not signed at this stage
482             cat > $rootfs_path/etc/yum.repos.d/myplc.repo <<EOF
483 [myplc]
484 name= MyPLC
485 baseurl=$REPO_URL
486 enabled=1
487 gpgcheck=0
488 EOF
489         fi
490     fi
491 }    
492
493 ##############################
494 # need to specify the right mirror for debian variants like ubuntu and the like
495 function debian_mirror () {
496     fcdistro=$1; shift
497     case $fcdistro in
498         squeeze|wheezy) 
499             echo http://ftp2.fr.debian.org/debian/ ;;
500         oneiric|precise|quantal|raring|saucy) 
501             echo http://mir1.ovh.net/ubuntu/ubuntu/ ;;
502         *) echo unknown distro $fcdistro; exit 1;;
503     esac
504 }
505
506 function debian_install () {
507     set -e
508     set -x
509     mkdir -p $rootfs_path
510     arch=$(canonical_arch $personality $fcdistro)
511     mirror=$(debian_mirror $fcdistro)
512     debootstrap --arch $arch $fcdistro $rootfs_path $mirror
513 }
514
515 function debian_configure () {
516     guest_interfaces=${rootfs_path}/etc/network/interfaces
517     ( [ -n "$BUILD_MODE" ] && write_guest_interfaces_build || write_guest_interfaces_test ) > $guest_interfaces
518 }
519
520 function write_guest_interfaces_build () {
521     cat <<EOF
522 auto $VIF_GUEST
523 iface $VIF_GUEST inet dhcp
524 EOF
525 }
526
527 function write_guest_interfaces_test () {
528     cat <<EOF
529 auto $VIF_GUEST
530 iface $VIF_GUEST
531     address $IP
532     netmask $NETMASK
533     gateway $GATEWAY
534 EOF
535 }
536 ##############################
537 function setup_lxc() {
538
539     set -x
540     set -e
541     #trap failure ERR INT
542
543     lxc=$1; shift
544     fcdistro=$1; shift
545     pldistro=$1; shift
546     personality=$1; shift
547
548     # create lxc container 
549     
550     pkg_method=$(package_method $fcdistro)
551     case $pkg_method in
552         yum)
553             fedora_install || { echo "failed to install fedora root image"; exit 1 ; }
554             fedora_configure || { echo "failed to configure fedora for a container"; exit 1 ; }
555             ;;
556         debootstrap)
557             debian_install || { echo "failed to install debian/ubuntu root image"; exit 1 ; }
558             debian_configure || { echo "failed to configure debian/ubuntu for a container"; exit 1 ; }
559             ;;
560         *)
561             echo "$COMMAND:: unknown package_method - exiting"
562             exit 1
563             ;;
564     esac
565
566     # Enable cgroup -- xxx -- is this really useful ?
567     mkdir $rootfs_path/cgroup
568     
569     # set up resolv.conf
570     cp /etc/resolv.conf $rootfs_path/etc/resolv.conf
571     # and /etc/hosts for at least localhost
572     [ -f $rootfs_path/etc/hosts ] || echo "127.0.0.1 localhost localhost.localdomain" > $rootfs_path/etc/hosts
573     
574     # grant ssh access from host to guest
575     mkdir $rootfs_path/root/.ssh
576     cat /root/.ssh/id_rsa.pub >> $rootfs_path/root/.ssh/authorized_keys
577     
578     # don't keep the input xml, this can be retrieved at all times with virsh dumpxml
579     config_xml=$tmp/$lxc.xml
580     ( [ -n "$BUILD_MODE" ] && write_lxc_xml_build $lxc || write_lxc_xml_test $lxc ) > $config_xml
581     
582     # define lxc container for libvirt
583     virsh -c lxc:/// define $config_xml
584
585     return 0
586 }
587
588 function write_lxc_xml_test () {
589     lxc=$1; shift
590     cat <<EOF
591 <domain type='lxc'>
592   <name>$lxc</name>
593   <memory>524288</memory>
594   <os>
595     <type arch='$arch2'>exe</type>
596     <init>/sbin/init</init>
597   </os>
598   <features>
599     <acpi/>
600   </features>
601   <vcpu>1</vcpu>
602   <clock offset='utc'/>
603   <on_poweroff>destroy</on_poweroff>
604   <on_reboot>restart</on_reboot>
605   <on_crash>destroy</on_crash>
606   <devices>
607     <emulator>/usr/libexec/libvirt_lxc</emulator>
608     <filesystem type='mount'>
609       <source dir='$rootfs_path'/>
610       <target dir='/'/>
611     </filesystem>
612     <interface type="bridge">
613       <source bridge="$PUBLIC_BRIDGE"/>
614       <target dev='$VIF_HOST'/>
615     </interface>
616     <console type='pty' />
617   </devices>
618   <network>
619     <name>host-bridge</name>
620     <forward mode="bridge"/>
621     <bridge name="$PUBLIC_BRIDGE"/>
622   </network>
623 </domain>
624 EOF
625 }
626
627 function write_lxc_xml_build () { 
628     lxc=$1; shift
629     cat <<EOF
630 <domain type='lxc'>
631   <name>$lxc</name>
632   <memory>524288</memory>
633   <os>
634     <type arch='$arch2'>exe</type>
635     <init>/sbin/init</init>
636   </os>
637   <features>
638     <acpi/>
639   </features>
640   <vcpu>1</vcpu>
641   <clock offset='utc'/>
642   <on_poweroff>destroy</on_poweroff>
643   <on_reboot>restart</on_reboot>
644   <on_crash>destroy</on_crash>
645   <devices>
646     <emulator>/usr/libexec/libvirt_lxc</emulator>
647     <filesystem type='mount'>
648       <source dir='$rootfs_path'/>
649       <target dir='/'/>
650     </filesystem>
651     <interface type="network">
652       <source network="default"/>
653     </interface>
654     <console type='pty' />
655   </devices>
656 </domain>
657 EOF
658 }
659
660 # this one is dhcp-based
661 function write_guest_ifcfg_build () {
662     cat <<EOF
663 DEVICE=$VIF_GUEST
664 BOOTPROTO=dhcp
665 ONBOOT=yes
666 NM_CONTROLLED=no
667 TYPE=Ethernet
668 MTU=1500
669 EOF
670 }
671
672 # use fixed IP as specified by GUEST_HOSTNAME
673 function write_guest_ifcfg_test () {
674     cat <<EOF
675 DEVICE=$VIF_GUEST
676 BOOTPROTO=static
677 ONBOOT=yes
678 HOSTNAME=$GUEST_HOSTNAME
679 IPADDR=$IP
680 NETMASK=$NETMASK
681 GATEWAY=$GATEWAY
682 NM_CONTROLLED=no
683 TYPE=Ethernet
684 MTU=1500
685 EOF
686 }
687
688 function devel_or_vtest_tools () {
689
690     set -x 
691     set -e 
692     trap failure ERR INT
693
694     lxc=$1; shift
695     fcdistro=$1; shift
696     pldistro=$1; shift
697     personality=$1; shift
698
699     pkg_method=$(package_method $fcdistro)
700
701     pkgsfile=$(pl_locateDistroFile $DIRNAME $pldistro $PREINSTALLED)
702
703     ### install individual packages, then groups
704     # get target arch - use uname -i here (we want either x86_64 or i386)
705    
706     lxc_arch=$(chroot $rootfs_path uname -i)
707     # on debian systems we get arch through the 'arch' command
708     [ "$lxc_arch" = "unknown" ] && lxc_arch=$(chroot $rootfs_path arch)
709
710     packages=$(pl_getPackages -a $lxc_arch $fcdistro $pldistro $pkgsfile)
711     groups=$(pl_getGroups -a $lxc_arch $fcdistro $pldistro $pkgsfile)
712
713     case "$pkg_method" in
714         yum)
715             [ -n "$packages" ] && chroot $rootfs_path yum -y install $packages
716             for group_plus in $groups; do
717                 group=$(echo $group_plus | sed -e "s,+++, ,g")
718                 chroot $rootfs_path yum -y groupinstall "$group"
719             done
720             # store current rpm list in /init-lxc.rpms in case we need to check the contents
721             chroot $rootfs_path rpm -aq > $rootfs_path/init-lxc.rpms
722             ;;
723         debootstrap)
724             # for ubuntu
725             if grep -iq ubuntu /vservers/$vserver/rootfs/etc/lsb-release 2> /dev/null; then
726                 # on ubuntu, at this point we end up with a single feed in /etc/apt/sources.list
727                 # we need at least to add the 'universe' feed for python-rpm
728                 ( cd /vservers/$vserver/rootfs/etc/apt ; head -1 sources.list | sed -e s,main,universe, > sources.list.d/universe.list )
729                 # also adding a link to updates sounds about right
730                 ( cd /vservers/$vserver/rootfs/etc/apt ; head -1 sources.list | sed -e 's, main,-updates main,' > sources.list.d/updates.list )
731             fi
732             chroot $rootfs_path apt-get update
733             for package in $packages ; do
734                 # close stdin in an attempt to avoid this hanging
735                 # xxx also we ignore result for now, not sure if the kind of errors like below
736                 # truly is serious or not
737 #Setting up at (3.1.13-2ubuntu2) ...
738 #initctl: Unable to connect to Upstart: Failed to connect to socket /com/ubuntu/upstart: Connection refused
739 #initctl: Unable to connect to Upstart: Failed to connect to socket /com/ubuntu/upstart: Connection refused
740 #start: Unable to connect to Upstart: Failed to connect to socket /com/ubuntu/upstart: Connection refused
741
742                 chroot $rootfs_path apt-get install -y $package < /dev/null || :
743             done
744             ### xxx todo install groups with apt..
745             ;;
746         *)
747             echo "unknown pkg_method $pkg_method"
748             ;;
749     esac
750
751     return 0
752 }
753
754 function post_install () {
755     lxc=$1; shift 
756     personality=$1; shift
757     if [ -n "$BUILD_MODE" ] ; then
758         post_install_build $lxc $personality
759         lxc_start $lxc
760         # manually run dhclient in guest - somehow this network won't start on its own
761         virsh -c lxc:/// lxc-enter-namespace $lxc $(bin_in_container $lxc dhclient) $VIF_GUEST
762     else
763         post_install_myplc $lxc $personality
764         lxc_start $lxc
765         wait_for_ssh $lxc
766     fi
767     # setup localtime from the host
768     cp /etc/localtime $rootfs_path/etc/localtime
769 }
770
771 function post_install_build () {
772
773     set -x 
774     set -e 
775     trap failure ERR INT
776
777     lxc=$1; shift
778     personality=$1; shift
779
780 ### From myplc-devel-native.spec
781 # be careful to backslash $ in this, otherwise it's the root context that's going to do the evaluation
782     cat << EOF | chroot $rootfs_path bash -x
783     # set up /dev/loop* in lxc
784     for i in \$(seq 0 255) ; do
785         /bin/mknod -m 640 /dev/loop\$i b 7 \$i
786     done
787     
788     # create symlink for /dev/fd
789     [ ! -e "/dev/fd" ] && /bin/ln -s /proc/self/fd /dev/fd
790
791     # modify /etc/rpm/macros to not use /sbin/new-kernel-pkg
792     /bin/sed -i 's,/sbin/new-kernel-pkg:,,' /etc/rpm/macros
793     if [ -h "/sbin/new-kernel-pkg" ] ; then
794         filename=\$(/bin/readlink -f /sbin/new-kernel-pkg)
795         if [ "\$filename" == "/sbin/true" ] ; then
796                 /bin/echo "WARNING: /sbin/new-kernel-pkg symlinked to /sbin/true"
797                 /bin/echo "\tmost likely /etc/rpm/macros has /sbin/new-kernel-pkg declared in _netsharedpath."
798                 /bin/echo "\tPlease remove /sbin/new-kernel-pkg from _netsharedpath and reintall mkinitrd."
799                 exit 1
800         fi
801     fi
802     
803     # customize root's prompt
804     /bin/cat << PROFILE > /root/.profile
805 export PS1="[$lxc] \\w # "
806 PROFILE
807
808     uid=2000
809     gid=2000
810     
811     # add a "build" user to the system
812     builduser=\$(grep "^build:" /etc/passwd | wc -l)
813     if [ \$builduser -eq 0 ] ; then
814         groupadd -o -g \$gid build;
815         useradd -o -c 'Automated Build' -u \$uid -g \$gid -n -M -s /bin/bash build;
816     fi
817
818 # Allow build user to build certain RPMs as root
819     if [ -f /etc/sudoers ] ; then
820         buildsudo=\$(grep "^build.*ALL=(ALL).*NOPASSWD:.*ALL"  /etc/sudoers | wc -l)
821         if [ \$buildsudo -eq 0 ] ; then
822             echo "build   ALL=(ALL)       NOPASSWD: ALL" >> /etc/sudoers
823         fi
824         sed -i 's,^Defaults.*requiretty,#Defaults requiretty,' /etc/sudoers
825     fi
826 #
827 EOF
828         
829 }
830
831 function post_install_myplc  () {
832     set -x 
833     set -e 
834     trap failure ERR INT
835
836     lxc=$1; shift
837     personality=$1; shift
838
839 # be careful to backslash $ in this, otherwise it's the root context that's going to do the evaluation
840     cat << EOF | chroot $rootfs_path bash -x
841
842     # create /etc/sysconfig/network if missing
843     [ -f /etc/sysconfig/network ] || /bin/echo NETWORKING=yes > /etc/sysconfig/network
844
845     # create symlink for /dev/fd
846     [ ! -e "/dev/fd" ] && /bin/ln -s /proc/self/fd /dev/fd
847
848     # turn off regular crond, as plc invokes plc_crond
849     /sbin/chkconfig crond off
850
851     # take care of loginuid in /etc/pam.d 
852     /bin/sed -i "s,#*\(.*loginuid.*\),#\1," /etc/pam.d/*
853
854     # customize root's prompt
855     /bin/cat << PROFILE > /root/.profile
856 export PS1="[$lxc] \\w # "
857 PROFILE
858
859 EOF
860 }
861
862 function lxc_start() {
863
864     set -x
865     set -e
866     #trap failure ERR INT
867
868     lxc=$1; shift
869   
870     virsh -c lxc:/// start $lxc
871   
872     return 0
873 }
874
875 function wait_for_ssh () {
876     set -x
877     set -e
878     #trap failure ERR INT
879
880     lxc=$1; shift
881   
882     echo $IP is up, waiting for ssh...
883
884     #wait max 5 min for sshd to start 
885     ssh_up=""
886     stop_time=$(($(date +%s) + 300))
887     current_time=$(date +%s)
888     
889     counter=1
890     while [ "$current_time" -lt "$stop_time" ] ; do
891          echo "$counter-th attempt to reach sshd in container $lxc ..."
892          ssh -o "StrictHostKeyChecking no" $IP 'uname -i' && { ssh_up=true; echo "SSHD in container $lxc is UP"; break ; } || :
893          sleep 10
894          current_time=$(($current_time + 10))
895          counter=$(($counter+1))
896     done
897
898     # Thierry: this is fatal, let's just exit with a failure here
899     [ -z $ssh_up ] && { echo "SSHD in container $lxc is not running" ; exit 1 ; } 
900     return 0
901 }
902
903 ####################
904 function failure () {
905     echo "$COMMAND : Bailing out"
906     exit 1
907 }
908
909 function usage () {
910     set +x 
911     echo "Usage: $COMMAND_LBUILD [options] lxc-name"
912     echo "Usage: $COMMAND_LTEST [options] lxc-name"
913     echo "Description:"
914     echo "   This command creates a fresh lxc instance, for building, or running a test myplc"
915     echo "Supported options"
916     echo " -f fcdistro - for creating the root filesystem - defaults to $DEFAULT_FCDISTRO"
917     echo " -d pldistro - defaults to $DEFAULT_PLDISTRO"
918     echo " -p personality - defaults to $DEFAULT_PERSONALITY"
919     echo " -n hostname - the hostname to use in container - required with $COMMAND_LTEST"
920     echo " -r repo-url - used to populate yum.repos.d - required with $COMMAND_LTEST"
921     echo " -P pkgs_file - defines the set of extra pacakges"
922     echo "    by default we use vtest.pkgs or devel.pkgs according to $COMMAND"
923     echo " -v be verbose"
924     exit 1
925 }
926
927 ### parse args and 
928 function main () {
929
930     #set -e
931     #trap failure ERR INT
932
933     if [ "$(id -u)" != "0" ]; then
934           echo "This script should be run as 'root'"
935           exit 1
936     fi
937
938     case "$COMMAND" in
939         $COMMAND_LBUILD)
940             BUILD_MODE=true ;;
941         $COMMAND_LTEST)
942             TEST_MODE=true;;
943         *)
944             usage ;;
945     esac
946
947     echo 'build mode=' $BUILD_MODE 'test mode=' $TEST_MODE
948
949     # the set of preinstalled packages - depends on vbuild or vtest
950     if [ -n "$BUILD_MODE" ] ; then
951         PREINSTALLED=devel.pkgs
952     else
953         PREINSTALLED=vtest.pkgs
954     fi
955     while getopts "f:d:p:n:r:P:v" opt ; do
956         case $opt in
957             f) fcdistro=$OPTARG;;
958             d) pldistro=$OPTARG;;
959             p) personality=$OPTARG;;
960             n) GUEST_HOSTNAME=$OPTARG;;
961             r) REPO_URL=$OPTARG;;
962             P) PREINSTALLED=$OPTARG;;
963             v) VERBOSE=true; set -x;;
964             *) usage ;;
965         esac
966     done
967         
968     shift $(($OPTIND - 1))
969
970     # parse fixed arguments
971     [[ -z "$@" ]] && usage
972     lxc=$1 ; shift
973
974     # check we've exhausted the arguments
975     [[ -n "$@" ]] && usage
976
977     [ -z "$fcdistro" ] && fcdistro=$DEFAULT_FCDISTRO
978     [ -z "$pldistro" ] && pldistro=$DEFAULT_PLDISTRO
979     [ -z "$personality" ] && personality=$DEFAULT_PERSONALITY
980     
981     if [ -n "$BUILD_MODE" ] ; then
982         [ -z "$GUEST_HOSTNAME" ] && GUEST_HOSTNAME=$lxc
983     else
984         [[ -z "$GUEST_HOSTNAME" ]] && usage
985         # use -r none to get rid of this warning
986         if [ "$REPO_URL" == "none" ] ; then
987             REPO_URL=""
988         elif [ -z "$REPO_URL" ] ; then
989             echo "WARNING -- setting up a yum repo is recommended" 
990         fi
991     fi
992
993     ##########
994     release=$(echo $fcdistro | cut -df -f2)
995
996     if [ "$personality" == "linux32" ]; then
997         arch=i386
998         arch2=i686
999     elif [ "$personality" == "linux64" ]; then
1000         arch=x86_64
1001         arch2=x86_64
1002     else
1003         echo "Unknown personality: $personality"
1004     fi
1005
1006     if [ -n "$BUILD_MODE" ] ; then
1007
1008         # Bridge IP affectation
1009         byte=$(random_private_byte)
1010         IP=${PRIVATE_PREFIX}$byte
1011         NETMASK=$(masklen_to_netmask $PRIVATE_MASKLEN)
1012         GATEWAY=$PRIVATE_GATEWAY
1013         VIF_HOST="i$byte"
1014     else
1015         [[ -z "GUEST_HOSTNAME" ]] && usage
1016        
1017         create_bridge_if_needed
1018
1019         IP=$(gethostbyname $GUEST_HOSTNAME)
1020         # use same NETMASK as bridge interface br0
1021         MASKLEN=$(ip addr show $PUBLIC_BRIDGE | grep -v inet6 | grep inet | awk '{print $2;}' | cut -d/ -f2)
1022         NETMASK=$(masklen_to_netmask $MASKLEN)
1023         GATEWAY=$(ip route show | grep default | awk '{print $3}')
1024         VIF_HOST="i$(echo $GUEST_HOSTNAME | cut -d. -f1)"
1025     fi
1026
1027     echo "the IP address of container $lxc is $IP, host virtual interface is $VIF_HOST"
1028
1029     path=/vservers
1030     [ ! -d $path ] && mkdir $path
1031     rootfs_path=$path/$lxc/rootfs
1032     config_path=$path/$lxc
1033     cache_base=/var/cache/lxc/fedora/$arch
1034     cache=$cache_base/$release
1035     
1036     # check whether the rootfs directory is created to know if the container exists
1037     # bacause /var/lib/lxc/$lxc is already created while putting $lxc.timestamp
1038     [ -d $rootfs_path ] && \
1039         { echo "container $lxc already exists in filesystem - exiting" ; exit 1 ; }
1040     virsh -c lxc:/// domuuid $lxc >& /dev/null && \
1041         { echo "container $lxc already exists in libvirt - exiting" ; exit 1 ; }
1042
1043     setup_lxc $lxc $fcdistro $pldistro $personality 
1044
1045     devel_or_vtest_tools $lxc $fcdistro $pldistro $personality
1046
1047     post_install $lxc $personality
1048     
1049     echo $COMMAND Done
1050 }
1051
1052 main "$@"